/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package eventtalkboard;


/**
 *
 * @author hansolo
 */
public class AnalogClockPanel extends javax.swing.JComponent implements java.awt.event.ActionListener
{
    private final double ANGLE_STEP = 6;    
    private final javax.swing.Timer clockTimer = new javax.swing.Timer(60000, this);
    private double minutePointerAngle = java.util.Calendar.getInstance().get(java.util.Calendar.MINUTE) * ANGLE_STEP;
    private double hourPointerAngle = java.util.Calendar.getInstance().get(java.util.Calendar.HOUR) * ANGLE_STEP * 5 + 0.5 * java.util.Calendar.getInstance().get( java.util.Calendar.MINUTE);
//    private double secondPointerAngle = java.util.Calendar.getInstance().get(java.util.Calendar.SECOND) * ANGLE_STEP;
    private final java.awt.geom.Rectangle2D HOUR_POINTER = new java.awt.geom.Rectangle2D.Float(52.5f, 21, 6, 34);
    private final java.awt.geom.Rectangle2D MINUTE_POINTER = new java.awt.geom.Rectangle2D.Float(52.5f, 7, 5, 48);
//    private final java.awt.geom.GeneralPath SECOND_POINTER;
//    private final java.awt.Color SECOND_COLOR = new java.awt.Color(0xF00000);
    private java.awt.image.BufferedImage backgroundImage = null;

    public AnalogClockPanel()
    {
        super();
        setSize(110, 110);
        java.awt.geom.GeneralPath secondArea = new java.awt.geom.GeneralPath();
        secondArea.moveTo(53.5f, 55);
        secondArea.lineTo(56.5f, 55);
        secondArea.lineTo(55.5f, 4);
        secondArea.lineTo(54.5f, 4);
        secondArea.closePath();
        java.awt.geom.Area second = new java.awt.geom.Area(secondArea);        
        second.add(new java.awt.geom.Area(new java.awt.geom.Ellipse2D.Float(50, 16, 10, 10)));
        second.subtract(new java.awt.geom.Area(new java.awt.geom.Ellipse2D.Float(51, 17, 8, 8)));
//        SECOND_POINTER = new java.awt.geom.GeneralPath(second);

        clockTimer.start();
    }


    @Override
    protected void paintComponent(java.awt.Graphics g)
    {
        java.awt.Graphics2D g2 = (java.awt.Graphics2D) g;

        g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING, java.awt.RenderingHints.VALUE_ANTIALIAS_ON);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ALPHA_INTERPOLATION, java.awt.RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_COLOR_RENDERING, java.awt.RenderingHints.VALUE_COLOR_RENDER_QUALITY);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_STROKE_CONTROL, java.awt.RenderingHints.VALUE_STROKE_PURE);

        java.awt.geom.AffineTransform oldTransform = g2.getTransform();

        // Draw background image
        if (backgroundImage == null)
        {
            backgroundImage = createBackgroundImage();
        }
        g2.drawImage(backgroundImage, 0, 0, null);

        // Draw hour pointer
        g2.setColor(java.awt.Color.WHITE);
        g2.rotate(Math.toRadians(hourPointerAngle), 55, 55);
        g2.fill(HOUR_POINTER);

        // Draw minute pointer
        g2.setTransform(oldTransform);        
        g2.rotate(Math.toRadians(minutePointerAngle), 55, 55);
        g2.fill(MINUTE_POINTER);

        // Draw second pointer
//        g2.setTransform(oldTransform);
//        g2.rotate(Math.toRadians(secondPointerAngle), 55, 55);
//        g2.setColor(SECOND_COLOR);
//        g2.fill(SECOND_POINTER);

        g2.setTransform(oldTransform);

        g2.setColor(java.awt.Color.WHITE);
        g2.fillOval(50, 50, 10, 10);

        g2.dispose();
    }

    private java.awt.image.BufferedImage createBackgroundImage()
    {
        java.awt.GraphicsConfiguration gfxConf = java.awt.GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice().getDefaultConfiguration();
        final java.awt.image.BufferedImage IMAGE = gfxConf.createCompatibleImage(110, 110, java.awt.Transparency.TRANSLUCENT);
        java.awt.Graphics2D g2 = IMAGE.createGraphics();

        g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING, java.awt.RenderingHints.VALUE_ANTIALIAS_ON);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ALPHA_INTERPOLATION, java.awt.RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_COLOR_RENDERING, java.awt.RenderingHints.VALUE_COLOR_RENDER_QUALITY);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_STROKE_CONTROL, java.awt.RenderingHints.VALUE_STROKE_PURE);

        java.awt.geom.AffineTransform oldTransform = g2.getTransform();

        // Draw clock background
        final java.awt.geom.Point2D LIGHT_START = new java.awt.geom.Point2D.Float(0, 0);
        final java.awt.geom.Point2D LIGHT_STOP = new java.awt.geom.Point2D.Float(0, 110);
        final float[] LIGHT_FRACTIONS =
        {
            0.0f,
            1.0f
        };
        final java.awt.Color[] LIGHT_COLORS =
        {
            new java.awt.Color(0x000000),
            new java.awt.Color(0x645E54)
        };
        final java.awt.LinearGradientPaint LIGHT_GRADIENT = new java.awt.LinearGradientPaint(LIGHT_START, LIGHT_STOP, LIGHT_FRACTIONS, LIGHT_COLORS);
        g2.setPaint(LIGHT_GRADIENT);
        g2.fill(new java.awt.geom.Ellipse2D.Float(0, 0, 110, 110));

        final java.awt.geom.Point2D BACKGROUND_START = new java.awt.geom.Point2D.Float(0, 1);
        final java.awt.geom.Point2D BACKGROUND_STOP = new java.awt.geom.Point2D.Float(0, 108);
        final float[] BACKGROUND_FRACTIONS =
        {
            0.0f,
            1.0f
        };
        final java.awt.Color[] BACKGROUND_COLORS =
        {
            new java.awt.Color(0x3E3B32),
            new java.awt.Color(0x232520)
        };
        final java.awt.LinearGradientPaint BACKGROUND_GRADIENT = new java.awt.LinearGradientPaint(BACKGROUND_START, BACKGROUND_STOP, BACKGROUND_FRACTIONS, BACKGROUND_COLORS);
        g2.setPaint(BACKGROUND_GRADIENT);
        g2.fill(new java.awt.geom.Ellipse2D.Float(1, 1, 108, 108));

        // Draw tickmarks
        g2.setColor(java.awt.Color.WHITE);
        for (int tickAngle = 0 ; tickAngle < 360 ; tickAngle += 6)
        {
            g2.setTransform(oldTransform);
            g2.rotate(Math.toRadians(tickAngle), 55, 55);
            g2.fill(new java.awt.geom.Rectangle2D.Float(54f, 4, 2, 4));
        }

        for (int tickAngle = 0 ; tickAngle < 360 ; tickAngle += 30)
        {
            g2.setTransform(oldTransform);
            g2.rotate(Math.toRadians(tickAngle), 55, 55);
            g2.fill(new java.awt.geom.Rectangle2D.Float(53f, 4, 4, 12));
        }

        g2.setTransform(oldTransform);

        g2.dispose();

        return IMAGE;
    }


    @Override
    public java.awt.Dimension getPreferredSize()
    {
        return new java.awt.Dimension(110, 110);
    }


    @Override
    public java.awt.Dimension getSize(java.awt.Dimension dim)
    {
        return new java.awt.Dimension(110, 110);
    }


    @Override
    public java.awt.Dimension getSize()
    {
        return new java.awt.Dimension(110, 110);
    }


    @Override
    public void actionPerformed(java.awt.event.ActionEvent event)
    {        
        // Seconds        
//        secondPointerAngle = java.util.Calendar.getInstance().get(java.util.Calendar.SECOND) * ANGLE_STEP + java.util.Calendar.getInstance().get(java.util.Calendar.MILLISECOND) * ANGLE_STEP / 1000;

        // Minutes
        minutePointerAngle = java.util.Calendar.getInstance().get(java.util.Calendar.MINUTE) * ANGLE_STEP;

        // Hours
        hourPointerAngle = java.util.Calendar.getInstance().get(java.util.Calendar.HOUR) * ANGLE_STEP * 5 + (0.5) * java.util.Calendar.getInstance().get( java.util.Calendar.MINUTE);
             
        repaint(0, 0, 110, 110);
    }
}
