/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package eventtalkboard;

/**
 *
 * @author hansolo
 */
public enum GlobalFlipCharImages
{
    INSTANCE;

    private final java.awt.Font CHAR_FONT = new java.awt.Font("Arial Narrow", 1, 20);
    public final java.awt.image.BufferedImage[] FLIP_IMAGE_ARRAY = createFlipImages();
    public final java.awt.image.BufferedImage[] TOP_CHAR_ARRAY = createTopCharImages();
    public final java.awt.image.BufferedImage[] BOTTOM_CHAR_ARRAY = createBottomCharImages();


    private java.awt.image.BufferedImage[] createTopCharImages()
    {
        final java.awt.image.BufferedImage[] IMAGE_ARRAY = new java.awt.image.BufferedImage[65];

        for (int ascii = 32 ; ascii < 97 ; ascii++)
        {
            IMAGE_ARRAY[ascii - 32] = createCharTopImage((char) ascii);
        }

        return IMAGE_ARRAY;
    }

    private java.awt.image.BufferedImage[] createBottomCharImages()
    {
        java.awt.image.BufferedImage[] IMAGE_ARRAY = new java.awt.image.BufferedImage[65];

        for (int ascii = 32 ; ascii < 97 ; ascii++)
        {
            IMAGE_ARRAY[ascii - 32] = createCharBottomImage((char) ascii);
        }

        return IMAGE_ARRAY;
    }

    private java.awt.image.BufferedImage[] createFlipImages()
    {
        final java.awt.image.BufferedImage[] IMAGE_ARRAY = new java.awt.image.BufferedImage[9];
        java.awt.GraphicsConfiguration gfxConf = java.awt.GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice().getDefaultConfiguration();

        // Flip Image 1
        java.awt.image.BufferedImage flipImg1 = gfxConf.createCompatibleImage(30, 40, java.awt.Transparency.TRANSLUCENT);
        java.awt.Graphics2D g2 = flipImg1.createGraphics();

        g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING, java.awt.RenderingHints.VALUE_ANTIALIAS_ON);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ALPHA_INTERPOLATION, java.awt.RenderingHints.VALUE_ALPHA_INTERPOLATION_SPEED);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_COLOR_RENDERING, java.awt.RenderingHints.VALUE_COLOR_RENDER_SPEED);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_STROKE_CONTROL, java.awt.RenderingHints.VALUE_STROKE_PURE);

        final java.awt.geom.GeneralPath FLIP1 = new java.awt.geom.GeneralPath();
        FLIP1.moveTo(4, 9);
        FLIP1.quadTo(4, 7, 7, 7);
        FLIP1.lineTo(24, 7);
        FLIP1.quadTo(26, 7, 26, 9);
        FLIP1.lineTo(25, 16);
        FLIP1.lineTo(24, 16);
        FLIP1.lineTo(24, 19);
        FLIP1.lineTo(6, 19);
        FLIP1.closePath();

        g2.setColor(new java.awt.Color(0x010006));
        g2.fill(FLIP1);

        g2.dispose();
        IMAGE_ARRAY[0] = flipImg1;

        // Flip Image 2
        java.awt.image.BufferedImage flipImg2 = gfxConf.createCompatibleImage(30, 40, java.awt.Transparency.TRANSLUCENT);
        g2 = flipImg2.createGraphics();

        g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING, java.awt.RenderingHints.VALUE_ANTIALIAS_ON);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ALPHA_INTERPOLATION, java.awt.RenderingHints.VALUE_ALPHA_INTERPOLATION_SPEED);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_COLOR_RENDERING, java.awt.RenderingHints.VALUE_COLOR_RENDER_SPEED);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_STROKE_CONTROL, java.awt.RenderingHints.VALUE_STROKE_PURE);

        final java.awt.geom.GeneralPath FLIP2 = new java.awt.geom.GeneralPath();
        FLIP2.moveTo(3, 12);
        FLIP2.quadTo(3, 10, 6, 10);
        FLIP2.lineTo(24, 10);
        FLIP2.quadTo(26, 10, 47, 12);
        FLIP2.lineTo(26, 17);
        FLIP2.lineTo(25, 17);
        FLIP2.lineTo(24, 19);
        FLIP2.lineTo(6, 19);
        FLIP2.lineTo(6, 17);
        FLIP2.lineTo(4, 17);
        FLIP2.closePath();

        g2.setColor(new java.awt.Color(0x010006));
        g2.fill(FLIP2);

        g2.dispose();
        IMAGE_ARRAY[1] = flipImg2;

        // Flip Image 3
        java.awt.image.BufferedImage flipImg3 = gfxConf.createCompatibleImage(30, 40, java.awt.Transparency.TRANSLUCENT);
        g2 = flipImg3.createGraphics();

        g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING, java.awt.RenderingHints.VALUE_ANTIALIAS_ON);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ALPHA_INTERPOLATION, java.awt.RenderingHints.VALUE_ALPHA_INTERPOLATION_SPEED);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_COLOR_RENDERING, java.awt.RenderingHints.VALUE_COLOR_RENDER_SPEED);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_STROKE_CONTROL, java.awt.RenderingHints.VALUE_STROKE_PURE);

        final java.awt.geom.GeneralPath FLIP3 = new java.awt.geom.GeneralPath();
        FLIP3.moveTo(2, 14);
        FLIP3.quadTo(2, 13, 5, 13);
        FLIP3.lineTo(25, 13);
        FLIP3.quadTo(28, 13, 28, 14);
        FLIP3.lineTo(26, 18);
        FLIP3.lineTo(25, 18);
        FLIP3.lineTo(24, 19);
        FLIP3.lineTo(6, 19);
        FLIP3.lineTo(5, 18);
        FLIP3.lineTo(4, 18);
        FLIP3.closePath();

        g2.setColor(new java.awt.Color(0x010006));
        g2.fill(FLIP3);

        g2.dispose();
        IMAGE_ARRAY[2] = flipImg3;

        // Flip Image 4
        java.awt.image.BufferedImage flipImg4 = gfxConf.createCompatibleImage(30, 40, java.awt.Transparency.TRANSLUCENT);
        g2 = flipImg4.createGraphics();

        g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING, java.awt.RenderingHints.VALUE_ANTIALIAS_ON);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ALPHA_INTERPOLATION, java.awt.RenderingHints.VALUE_ALPHA_INTERPOLATION_SPEED);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_COLOR_RENDERING, java.awt.RenderingHints.VALUE_COLOR_RENDER_SPEED);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_STROKE_CONTROL, java.awt.RenderingHints.VALUE_STROKE_PURE);

        final java.awt.geom.GeneralPath FLIP4 = new java.awt.geom.GeneralPath();
        FLIP4.moveTo(2, 17);
        FLIP4.quadTo(2, 16, 5, 16);
        FLIP4.lineTo(25, 16);
        FLIP4.quadTo(28, 16, 28, 17);
        FLIP4.lineTo(26, 18);
        FLIP4.lineTo(25, 18);
        FLIP4.lineTo(24, 19);
        FLIP4.lineTo(6, 19);
        FLIP4.lineTo(5, 18);
        FLIP4.lineTo(4, 18);
        FLIP4.closePath();

        g2.setColor(new java.awt.Color(0x010006));
        g2.fill(FLIP4);

        g2.dispose();
        IMAGE_ARRAY[3] = flipImg4;

        // Flip Image 5
        java.awt.image.BufferedImage flipImg5 = gfxConf.createCompatibleImage(30, 40, java.awt.Transparency.TRANSLUCENT);
        g2 = flipImg5.createGraphics();

        g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING, java.awt.RenderingHints.VALUE_ANTIALIAS_ON);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ALPHA_INTERPOLATION, java.awt.RenderingHints.VALUE_ALPHA_INTERPOLATION_SPEED);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_COLOR_RENDERING, java.awt.RenderingHints.VALUE_COLOR_RENDER_SPEED);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_STROKE_CONTROL, java.awt.RenderingHints.VALUE_STROKE_PURE);

        final java.awt.geom.GeneralPath FLIP5 = new java.awt.geom.GeneralPath();
        FLIP5.moveTo(2, 19);
        FLIP5.lineTo(28, 19);
        FLIP5.lineTo(28, 20);
        FLIP5.lineTo(2, 20);
        FLIP5.closePath();

        g2.setColor(new java.awt.Color(0x010006));
        g2.fill(FLIP5);

        g2.dispose();
        IMAGE_ARRAY[4] = flipImg5;

        // Flip Image 6
        java.awt.image.BufferedImage flipImg6 = gfxConf.createCompatibleImage(30, 40, java.awt.Transparency.TRANSLUCENT);
        g2 = flipImg6.createGraphics();

        g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING, java.awt.RenderingHints.VALUE_ANTIALIAS_ON);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ALPHA_INTERPOLATION, java.awt.RenderingHints.VALUE_ALPHA_INTERPOLATION_SPEED);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_COLOR_RENDERING, java.awt.RenderingHints.VALUE_COLOR_RENDER_SPEED);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_STROKE_CONTROL, java.awt.RenderingHints.VALUE_STROKE_PURE);

        final java.awt.geom.GeneralPath FLIP6 = new java.awt.geom.GeneralPath();
        FLIP6.moveTo(4, 21);
        FLIP6.lineTo(5, 21);
        FLIP6.lineTo(6, 20);
        FLIP6.lineTo(24, 20);
        FLIP6.lineTo(25, 21);
        FLIP6.lineTo(26, 21);
        FLIP6.lineTo(28, 22);
        FLIP6.quadTo(28, 23, 25, 23);
        FLIP6.lineTo(5, 23);
        FLIP6.quadTo(2, 23, 2, 22);
        FLIP6.closePath();

        g2.setColor(new java.awt.Color(0x45483D));
        g2.fill(FLIP6);

        g2.dispose();
        IMAGE_ARRAY[5] = flipImg6;

        // Flip Image 7
        java.awt.image.BufferedImage flipImg7 = gfxConf.createCompatibleImage(30, 40, java.awt.Transparency.TRANSLUCENT);
        g2 = flipImg7.createGraphics();

        g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING, java.awt.RenderingHints.VALUE_ANTIALIAS_ON);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ALPHA_INTERPOLATION, java.awt.RenderingHints.VALUE_ALPHA_INTERPOLATION_SPEED);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_COLOR_RENDERING, java.awt.RenderingHints.VALUE_COLOR_RENDER_SPEED);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_STROKE_CONTROL, java.awt.RenderingHints.VALUE_STROKE_PURE);

        final java.awt.geom.GeneralPath FLIP7 = new java.awt.geom.GeneralPath();
        FLIP7.moveTo(4, 21);
        FLIP7.lineTo(5, 21);
        FLIP7.lineTo(6, 20);
        FLIP7.lineTo(24, 20);
        FLIP7.lineTo(25, 21);
        FLIP7.lineTo(26, 21);
        FLIP7.lineTo(28, 25);
        FLIP7.quadTo(28, 26, 25, 26);
        FLIP7.lineTo(5, 26);
        FLIP7.quadTo(2, 26, 2, 25);

        g2.setColor(new java.awt.Color(0x45483D));
        g2.fill(FLIP7);

        g2.dispose();
        IMAGE_ARRAY[6] = flipImg7;

        // Flip Image 8
        java.awt.image.BufferedImage flipImg8 = gfxConf.createCompatibleImage(30, 40, java.awt.Transparency.TRANSLUCENT);
        g2 = flipImg8.createGraphics();

        g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING, java.awt.RenderingHints.VALUE_ANTIALIAS_ON);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ALPHA_INTERPOLATION, java.awt.RenderingHints.VALUE_ALPHA_INTERPOLATION_SPEED);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_COLOR_RENDERING, java.awt.RenderingHints.VALUE_COLOR_RENDER_SPEED);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_STROKE_CONTROL, java.awt.RenderingHints.VALUE_STROKE_PURE);
       
        final java.awt.geom.GeneralPath FLIP8 = new java.awt.geom.GeneralPath();
        FLIP8.moveTo(4, 22);
        FLIP8.lineTo(5, 22);
        FLIP8.lineTo(6, 20);
        FLIP8.lineTo(24, 20);
        FLIP8.lineTo(25, 22);
        FLIP8.lineTo(26, 22);
        FLIP8.lineTo(27, 27);
        FLIP8.quadTo(27, 29, 24, 29);
        FLIP8.lineTo(6, 29);
        FLIP8.quadTo(3, 29, 3, 27);

        g2.setColor(new java.awt.Color(0x45483D));
        g2.fill(FLIP8);

        g2.dispose();
        IMAGE_ARRAY[7] = flipImg8;

        // Flip Image 9
        java.awt.image.BufferedImage flipImg9 = gfxConf.createCompatibleImage(30, 40, java.awt.Transparency.TRANSLUCENT);
        g2 = flipImg9.createGraphics();

        g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING, java.awt.RenderingHints.VALUE_ANTIALIAS_ON);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ALPHA_INTERPOLATION, java.awt.RenderingHints.VALUE_ALPHA_INTERPOLATION_SPEED);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_COLOR_RENDERING, java.awt.RenderingHints.VALUE_COLOR_RENDER_SPEED);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_STROKE_CONTROL, java.awt.RenderingHints.VALUE_STROKE_PURE);

        final java.awt.geom.GeneralPath FLIP9 = new java.awt.geom.GeneralPath();
        FLIP9.moveTo(5, 23);
        FLIP9.lineTo(6, 23);
        FLIP9.lineTo(6, 20);
        FLIP9.lineTo(24, 20);
        FLIP9.lineTo(24, 23);
        FLIP9.lineTo(25, 23);
        FLIP9.lineTo(26, 30);
        FLIP9.quadTo(26, 32, 24, 32);
        FLIP9.lineTo(7, 32);
        FLIP9.quadTo(4, 32, 4, 30);

        g2.setColor(new java.awt.Color(0x45483D));
        g2.fill(FLIP9);

        g2.dispose();
        IMAGE_ARRAY[8] = flipImg9;

        return IMAGE_ARRAY;
    }

    private java.awt.image.BufferedImage createCharTopImage(char character)
    {
        java.awt.GraphicsConfiguration gfxConf = java.awt.GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice().getDefaultConfiguration();
        final java.awt.image.BufferedImage IMAGE = gfxConf.createCompatibleImage(20, 15, java.awt.Transparency.TRANSLUCENT);
        java.awt.Graphics2D g2 = IMAGE.createGraphics();

        g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING, java.awt.RenderingHints.VALUE_ANTIALIAS_ON);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_TEXT_ANTIALIASING, java.awt.RenderingHints.VALUE_TEXT_ANTIALIAS_ON);        
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ALPHA_INTERPOLATION, java.awt.RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_COLOR_RENDERING, java.awt.RenderingHints.VALUE_COLOR_RENDER_QUALITY);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_STROKE_CONTROL, java.awt.RenderingHints.VALUE_STROKE_PURE);

        final java.awt.geom.GeneralPath TOP = new java.awt.geom.GeneralPath();
        TOP.moveTo(0, 3);
        TOP.quadTo(0, 0, 3, 0);
        TOP.lineTo(IMAGE.getWidth() - 3, 0);
        TOP.quadTo(IMAGE.getWidth(), 0, IMAGE.getWidth(), 3);
        TOP.lineTo(IMAGE.getWidth(), IMAGE.getHeight() - 4);
        TOP.lineTo(IMAGE.getWidth() - 1, IMAGE.getHeight() - 4);
        TOP.lineTo(IMAGE.getWidth() - 1, IMAGE.getHeight());
        TOP.lineTo(1, IMAGE.getHeight());
        TOP.lineTo(1, IMAGE.getHeight() - 4);
        TOP.lineTo(0, IMAGE.getHeight() - 4);
        TOP.closePath();

        final java.awt.geom.Point2D START = new java.awt.geom.Point2D.Float(0, 0);
        final java.awt.geom.Point2D STOP = new java.awt.geom.Point2D.Float(0, IMAGE.getHeight());

        final float[] FRACTIONS =
        {
            0.0f,
            1.0f
        };

        final java.awt.Color[] COLORS =
        {
            new java.awt.Color(0x4F5054),
            new java.awt.Color(0x3E4043)
        };

        final java.awt.LinearGradientPaint TOP_GRADIENT = new java.awt.LinearGradientPaint(START, STOP, FRACTIONS, COLORS);

        g2.setPaint(TOP_GRADIENT);
        g2.fill(TOP);

        final float[] TOP_SHADE_FRACTIONS =
        {
            0.0f,
            0.9f,
            1.0f
        };

        final java.awt.Color[] TOP_SHADE_COLORS =
        {
            new java.awt.Color(0.0f, 0.0f, 0.0f, 0.0f),
            new java.awt.Color(0.0f ,0.0f, 0.0f, 0.0f),
            new java.awt.Color(0.0f ,0.0f, 0.0f, 0.5f),
        };

        final java.awt.LinearGradientPaint TOP_SHADE_GRADIENT = new java.awt.LinearGradientPaint(START, STOP, TOP_SHADE_FRACTIONS, TOP_SHADE_COLORS);

        final java.awt.geom.Point2D FONT_GRADIENT_START = new java.awt.geom.Point2D.Float(0, 5);
        final java.awt.geom.Point2D FONT_GRADIENT_STOP = new java.awt.geom.Point2D.Float(0, 15);

        final float[] FONT_GRADIENT_FRACTIONS =
        {
            0.0f,
            1.0f
        };

        final java.awt.Color[] FONT_GRADIENT_COLORS =
        {
            new java.awt.Color(0xFFFEA7),
            new java.awt.Color(0xCCCB74)
        };

        final java.awt.LinearGradientPaint FONT_GRADIENT = new java.awt.LinearGradientPaint(FONT_GRADIENT_START, FONT_GRADIENT_STOP, FONT_GRADIENT_FRACTIONS, FONT_GRADIENT_COLORS);

        g2.setPaint(FONT_GRADIENT);
        
        g2.setFont(CHAR_FONT);
        final java.awt.FontMetrics METRICS = g2.getFontMetrics();
        final java.awt.geom.Rectangle2D CHAR_BOUNDARY = METRICS.getStringBounds(Character.toString(character), g2);

        g2.drawString(Character.toString(character), (int) ((IMAGE.getWidth() - CHAR_BOUNDARY.getWidth()) / 2), (IMAGE.getHeight() + (METRICS.getHeight() / 2) - METRICS.getDescent()));

        g2.setPaint(TOP_SHADE_GRADIENT);
        g2.fill(TOP);

        g2.dispose();

        return IMAGE;
    }

    private java.awt.image.BufferedImage createCharBottomImage(char character)
    {
        java.awt.GraphicsConfiguration gfxConf = java.awt.GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice().getDefaultConfiguration();
        final java.awt.image.BufferedImage IMAGE = gfxConf.createCompatibleImage(20, 15, java.awt.Transparency.TRANSLUCENT);
        java.awt.Graphics2D g2 = IMAGE.createGraphics();

//        final java.awt.image.VolatileImage IMAGE = gfxConf.createCompatibleVolatileImage(20, 15, java.awt.Transparency.OPAQUE);
//        IMAGE.validate(gfxConf);
//        java.awt.Graphics2D g2 = IMAGE.createGraphics();

        g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING, java.awt.RenderingHints.VALUE_ANTIALIAS_ON);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_TEXT_ANTIALIASING, java.awt.RenderingHints.VALUE_TEXT_ANTIALIAS_ON);        
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ALPHA_INTERPOLATION, java.awt.RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_COLOR_RENDERING, java.awt.RenderingHints.VALUE_COLOR_RENDER_QUALITY);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_STROKE_CONTROL, java.awt.RenderingHints.VALUE_STROKE_PURE);

        final java.awt.geom.GeneralPath BOTTOM = new java.awt.geom.GeneralPath();
        BOTTOM.moveTo(1, 0);
        BOTTOM.lineTo(IMAGE.getWidth() - 1, 0);
        BOTTOM.lineTo(IMAGE.getWidth() - 1, 4);
        BOTTOM.lineTo(IMAGE.getWidth(), 4);
        BOTTOM.lineTo(IMAGE.getWidth(), IMAGE.getHeight() - 3);
        BOTTOM.quadTo(IMAGE.getWidth(), IMAGE.getHeight(), IMAGE.getWidth() - 3, IMAGE.getHeight());
        BOTTOM.lineTo(3, IMAGE.getHeight());
        BOTTOM.quadTo(0, IMAGE.getHeight(), 0, IMAGE.getHeight() - 3);
        BOTTOM.lineTo(0, 4);
        BOTTOM.lineTo(1, 4);
        BOTTOM.closePath();

        final java.awt.geom.Point2D START = new java.awt.geom.Point2D.Float(0, 0);
        final java.awt.geom.Point2D STOP = new java.awt.geom.Point2D.Float(0, IMAGE.getHeight());

        final float[] FRACTIONS =
        {
            0.0f,
            1.0f
        };

        final java.awt.Color[] COLORS =
        {
            new java.awt.Color(0x3B3C40),
            new java.awt.Color(0x4C4D51)
        };

        final java.awt.LinearGradientPaint BOTTOM_GRADIENT = new java.awt.LinearGradientPaint(START, STOP, FRACTIONS, COLORS);

        g2.setPaint(BOTTOM_GRADIENT);
        g2.fill(BOTTOM);

        final java.awt.geom.Point2D FONT_GRADIENT_START = new java.awt.geom.Point2D.Float(0, 0);
        final java.awt.geom.Point2D FONT_GRADIENT_STOP = new java.awt.geom.Point2D.Float(0, 10);

        final float[] FONT_GRADIENT_FRACTIONS =
        {
            0.0f,
            1.0f
        };

        final java.awt.Color[] FONT_GRADIENT_COLORS =
        {
            new java.awt.Color(0xCCCB74),
            new java.awt.Color(0xFFFEA7)
        };

        final java.awt.LinearGradientPaint FONT_GRADIENT = new java.awt.LinearGradientPaint(FONT_GRADIENT_START, FONT_GRADIENT_STOP, FONT_GRADIENT_FRACTIONS, FONT_GRADIENT_COLORS);

        g2.setPaint(FONT_GRADIENT);

        g2.setFont(CHAR_FONT);
        final java.awt.FontMetrics METRICS = g2.getFontMetrics();
        final java.awt.geom.Rectangle2D CHAR_BOUNDARY = METRICS.getStringBounds(Character.toString(character), g2);

        g2.drawString(Character.toString(character), (int) ((IMAGE.getWidth() - CHAR_BOUNDARY.getWidth()) / 2), ((METRICS.getHeight() / 2) - METRICS.getDescent()));

        g2.dispose();

        return IMAGE;
    }
}
