/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package eventtalkboard;

/**
 *
 * @author hansolo
 */
public class GlobalTimedFlipChar extends javax.swing.JComponent implements java.awt.event.ActionListener
{
    private String character = " ";
    private static final String PROPERTY_CHARACTER = "character";
    private java.awt.image.BufferedImage backgroundImage = null;
    private final java.awt.BasicStroke THIN_STROKE = new java.awt.BasicStroke(0.5f);
    private char currentChar = 32;
    private java.awt.image.BufferedImage currentTopImage = null;
    private java.awt.image.BufferedImage currentBottomImage = null;
    private java.awt.image.BufferedImage flipSequenceImage = null;
    private volatile int currentFlipSequenceImage = 0;
    private final GlobalFlipCharImages IMAGE_CACHE = GlobalFlipCharImages.INSTANCE;
    private boolean reachedChar = false;
    private boolean flipComplete = false;

    // Some finals for the drawing
    // SideBars
    private final java.awt.geom.Point2D SIDE_BAR_START = new java.awt.geom.Point2D.Float(0, 13);
    private final java.awt.geom.Point2D SIDE_BAR_STOP = new java.awt.geom.Point2D.Float(0, 21);
    private final float[] SIDE_BAR_FRACTIONS =
    {
        0.0f,
        0.05f,
        0.15f,
        0.85f,
        0.95f,
        1.0f
    };
    private final java.awt.Color[] SIDE_BAR_COLORS =
    {
        new java.awt.Color(0x4A4945),
        new java.awt.Color(0x787876),
        new java.awt.Color(0x474C48),
        new java.awt.Color(0x534F44),
        new java.awt.Color(0x7B7168),
        new java.awt.Color(0x564C43)
    };
    private final java.awt.LinearGradientPaint SIDE_BAR_GRADIENT = new java.awt.LinearGradientPaint(SIDE_BAR_START, SIDE_BAR_STOP, SIDE_BAR_FRACTIONS, SIDE_BAR_COLORS);

    // FlipAxis
    private final java.awt.Color FLIP_AXIS_TOP_COLOR = new java.awt.Color(0x999999);
    private final java.awt.Color FLIP_AXIS_BOTTOM_COLOR = java.awt.Color.BLACK;
    private final java.awt.geom.Line2D FLIP_AXIS_TOP = new java.awt.geom.Line2D.Float(2, 17, 24, 17);
    private final java.awt.geom.Line2D FLIP_AXIS_BOTTOM = new java.awt.geom.Line2D.Float(2, 18, 24, 18);

    // Highlight Colors
    private final java.awt.Color HIGHLIGHT_COLOR_TOP = new java.awt.Color(0x000000);
    private final java.awt.Color HIGHLIGHT_COLOR_BOTTOM = new java.awt.Color(0x625C52);


    public GlobalTimedFlipChar()
    {
        setOpaque(false);
        GlobalTimer.INSTANCE.addComponent(this);
    }

    @Override
    protected void paintComponent(java.awt.Graphics g)
    {
        java.awt.Graphics2D g2 = (java.awt.Graphics2D) g.create();
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING, java.awt.RenderingHints.VALUE_ANTIALIAS_ON);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ALPHA_INTERPOLATION, java.awt.RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_COLOR_RENDERING, java.awt.RenderingHints.VALUE_COLOR_RENDER_QUALITY);        
        g2.setRenderingHint(java.awt.RenderingHints.KEY_DITHERING, java.awt.RenderingHints.VALUE_DITHER_ENABLE);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_RENDERING, java.awt.RenderingHints.VALUE_RENDER_QUALITY);

        // Draw instrument background
        if (backgroundImage == null)
        {
            backgroundImage = createBackgroundImage();
        }
        g2.drawImage(backgroundImage, 0, 0, this);

        // Draw flip axis
        g2.setStroke(THIN_STROKE);
        g2.setColor(FLIP_AXIS_TOP_COLOR);
        g2.draw(FLIP_AXIS_TOP);
        g2.setColor(FLIP_AXIS_BOTTOM_COLOR);
        g2.draw(FLIP_AXIS_BOTTOM);

        // Draw side bars
        g2.setPaint(SIDE_BAR_GRADIENT);
        g2.drawLine(2, 13, 2, 21);
        g2.drawLine(23, 13, 23, 21);


        g2.drawImage(currentTopImage, 3, 2, this);

        g2.drawImage(currentBottomImage, 3, 18, this);

        if (flipSequenceImage != null)
        {
            g2.drawImage(flipSequenceImage, -2, -2, this);
        }

        // Highlight
        g2.setColor(HIGHLIGHT_COLOR_TOP);
        g2.drawLine(0, 0, getWidth(), 0);

        g2.setColor(HIGHLIGHT_COLOR_BOTTOM);
        g2.drawLine(0, getHeight(), getWidth(), getHeight());


        g2.dispose();
    }

    private java.awt.image.BufferedImage createBackgroundImage()
    {
        java.awt.GraphicsConfiguration gfxConf = java.awt.GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice().getDefaultConfiguration();
        final java.awt.image.BufferedImage IMAGE = gfxConf.createCompatibleImage(getWidth(), getHeight(), java.awt.Transparency.OPAQUE);        
        java.awt.Graphics2D g2 = IMAGE.createGraphics();

        g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING, java.awt.RenderingHints.VALUE_ANTIALIAS_ON);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ALPHA_INTERPOLATION, java.awt.RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_COLOR_RENDERING, java.awt.RenderingHints.VALUE_COLOR_RENDER_QUALITY);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_STROKE_CONTROL, java.awt.RenderingHints.VALUE_STROKE_PURE);
        
        // Inner Background
        final java.awt.geom.Point2D START_INNER_BACKGROUND = new java.awt.geom.Point2D.Float(0, 0);
        final java.awt.geom.Point2D STOP_INNER_BACKGROUND = new java.awt.geom.Point2D.Float(0, getHeight());

        final float[] FRACTIONS_INNER_BACKGROUND =
        {
            0.0f,
            1.0f
        };

        final java.awt.Color[] COLORS_INNER_BACKGROUND =
        {
            new java.awt.Color(0x3D3A31),
            new java.awt.Color(0x232520)
        };

        final java.awt.LinearGradientPaint GRADIENT_INNER_BACKGROUND = new java.awt.LinearGradientPaint(START_INNER_BACKGROUND, STOP_INNER_BACKGROUND, FRACTIONS_INNER_BACKGROUND, COLORS_INNER_BACKGROUND);

        g2.setPaint(GRADIENT_INNER_BACKGROUND);
        g2.fill(new java.awt.geom.Rectangle2D.Float(0, 0, getWidth(), getHeight()));

        // Highlight
        g2.setColor(HIGHLIGHT_COLOR_TOP);
        g2.drawLine(0, 0, getWidth(), 0);

        g2.setColor(HIGHLIGHT_COLOR_BOTTOM);
        g2.drawLine(0, getHeight(), getWidth(), getHeight());

        g2.dispose();

        return IMAGE;
    }

    public String getCharacter()
    {
        return this.character;
    }

    public void setCharacter(String character)
    {
        String oldCharacter = this.character;
        this.character = character;
        firePropertyChange(PROPERTY_CHARACTER, oldCharacter, character);
        if (currentChar != this.character.charAt(0))
        {
            reachedChar = false;
            flipComplete = false;
        }
    }

    @Override
    public java.awt.Dimension getSize()
    {
        return new java.awt.Dimension(30, 40);
    }

    @Override
    public java.awt.Dimension getPreferredSize()
    {
        return new java.awt.Dimension(26, 35);
    }

    @Override
    public java.awt.Dimension getSize(java.awt.Dimension rv)
    {
        return new java.awt.Dimension(26, 35);
    }

    @Override
    public void actionPerformed(java.awt.event.ActionEvent event)
    {
        if (event.getActionCommand().equals("flip") && !reachedChar)
        {            
            currentChar++;
            if (currentChar > 96)
            {
                currentChar = 32;
            }
            if (currentTopImage != null)
            {
                currentTopImage.flush();
            }            
            currentTopImage = IMAGE_CACHE.INSTANCE.TOP_CHAR_ARRAY[currentChar - 32];

            javax.swing.SwingUtilities.invokeLater(new java.lang.Runnable()
            {
                @Override
                public void run()
                {
                    // Repaint only the are of the flipping images
                    repaint(2, 7, 28, 32);
                    //repaint(3, 4, 27, 36);
                }
            });
            flipComplete = false;


            if (currentChar == this.character.charAt(0))
            {
                reachedChar = true;
            }            
        }

        if (event.getActionCommand().equals("flipSequence") && !flipComplete)
        {
            if (currentFlipSequenceImage == 9)
            {
                if (currentBottomImage != null)
                {
                    currentBottomImage.flush();
                }                
                currentBottomImage = IMAGE_CACHE.INSTANCE.BOTTOM_CHAR_ARRAY[currentChar - 32];
                currentFlipSequenceImage = 0;
                flipSequenceImage = null;
                flipComplete = true;
                repaint(0, 5, 25, 30);
            }
            else
            {
                flipSequenceImage = IMAGE_CACHE.FLIP_IMAGE_ARRAY[currentFlipSequenceImage];
                currentFlipSequenceImage++;
                repaint(0, 0, 25, 30);
            }
        }
    }
}
