/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package eventtalkboard;



/**
 *
 * @author hansolo
 */
public enum GlobalTimer implements java.awt.event.ActionListener
{
    INSTANCE;

    private static final java.awt.event.ActionEvent FLIP_EVENT = new java.awt.event.ActionEvent("flip", java.awt.event.ActionEvent.ACTION_PERFORMED, "flip");
    private static final java.awt.event.ActionEvent FLIP_SEQUENCE_EVENT = new java.awt.event.ActionEvent("flipSequence", java.awt.event.ActionEvent.ACTION_PERFORMED, "flipSequence");
    private javax.swing.Timer flipTimer = new javax.swing.Timer(180, this);
    private javax.swing.Timer flipSequenceTimer = new javax.swing.Timer(12, this);
    private int currentSequence = 0;

    private java.util.Set<GlobalTimedFlipChar> componentSet = new java.util.HashSet<GlobalTimedFlipChar>();

    GlobalTimer()
    {
        flipTimer.start();

    }

    public void addComponent(GlobalTimedFlipChar component)
    {
        this.componentSet.add(component);
    }

    public void removeComponent(GlobalTimedFlipChar component)
    {
        this.componentSet.remove(component);
    }

    @Override
    public void actionPerformed(java.awt.event.ActionEvent event)
    {
        if (event.getSource().equals(flipTimer))
        {
            for (GlobalTimedFlipChar component : componentSet)
            {
                component.actionPerformed(FLIP_EVENT);
            }

            flipSequenceTimer.start();
        }

        if (event.getSource().equals(flipSequenceTimer))
        {
            if (currentSequence == 10)
            {
                currentSequence = 0;
                flipSequenceTimer.stop();
            }

            for (GlobalTimedFlipChar component : componentSet)
            {
                component.actionPerformed(FLIP_SEQUENCE_EVENT);
            }
            currentSequence++;
         }
    }
}
