/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

package eventtalkboard;


/**
 *
 * @author hansolo
 */
public class LedPanel extends javax.swing.JComponent implements java.awt.event.ActionListener
{
    private final javax.swing.Timer BLINKING_TIMER = new javax.swing.Timer(500, this);
    private final java.awt.image.BufferedImage LED_OFF_OFF = createLedImage(0);
    private final java.awt.image.BufferedImage LED_ON_OFF = createLedImage(1);
    private final java.awt.image.BufferedImage LED_OFF_ON = createLedImage(2);
    private java.awt.image.BufferedImage currentImage;
    private boolean blinking = false;
    private boolean toggle;

    public LedPanel()
    {
        super();        
        this.currentImage = LED_OFF_OFF;
        toggle = false;        
    }

    @Override
    protected void paintComponent(java.awt.Graphics g)
    {
        super.paintComponent(g);

        java.awt.Graphics2D g2 = (java.awt.Graphics2D) g;
        g2.drawImage(currentImage, 0, 0, this);
    }


    private java.awt.image.BufferedImage createLedImage(int state)
    {
        java.awt.GraphicsConfiguration gfxConf = java.awt.GraphicsEnvironment.getLocalGraphicsEnvironment().getDefaultScreenDevice().getDefaultConfiguration();
        final java.awt.image.BufferedImage IMAGE = gfxConf.createCompatibleImage(20, 35, java.awt.Transparency.TRANSLUCENT);
        java.awt.Graphics2D g2 = IMAGE.createGraphics();

        g2.setRenderingHint(java.awt.RenderingHints.KEY_ANTIALIASING, java.awt.RenderingHints.VALUE_ANTIALIAS_ON);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_ALPHA_INTERPOLATION, java.awt.RenderingHints.VALUE_ALPHA_INTERPOLATION_QUALITY);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_COLOR_RENDERING, java.awt.RenderingHints.VALUE_COLOR_RENDER_QUALITY);
        g2.setRenderingHint(java.awt.RenderingHints.KEY_STROKE_CONTROL, java.awt.RenderingHints.VALUE_STROKE_PURE);

        // Define led data
        final java.awt.geom.Ellipse2D UPPER_LED = new java.awt.geom.Ellipse2D.Float(5, 5, 10, 10);
        final java.awt.geom.Ellipse2D UPPER_LED_CORONA = new java.awt.geom.Ellipse2D.Float(0, 0, 20, 20);
        final java.awt.geom.Ellipse2D LOWER_LED = new java.awt.geom.Ellipse2D.Float(5, 20, 10, 10);
        final java.awt.geom.Ellipse2D LOWER_LED_CORONA = new java.awt.geom.Ellipse2D.Float(0, 15, 20, 20);

        final java.awt.geom.Point2D UPPER_LED_CENTER = new java.awt.geom.Point2D.Double(UPPER_LED.getCenterX(), UPPER_LED.getCenterY());
        final java.awt.geom.Point2D LOWER_LED_CENTER = new java.awt.geom.Point2D.Double(LOWER_LED.getCenterX(), LOWER_LED.getCenterY());

        final float[] LED_FRACTIONS =
        {
            0.0f,
            0.2f,
            1.0f
        };

        final java.awt.Color[] LED_OFF_COLORS =
        {
            new java.awt.Color(0x1C7E00),
            new java.awt.Color(0x1C7E00),
            new java.awt.Color(0x1B6400)
        };

        final java.awt.Color[] LED_ON_COLORS =
        {
            new java.awt.Color(0x9AFF89),
            new java.awt.Color(0x9AFF89),
            new java.awt.Color(0x59FF2A)
        };

        final float[] LED_INNER_SHADOW_FRACTIONS =
        {
            0.0f,
            0.8f,
            1.0f
        };

        final java.awt.Color[] LED_INNER_SHADOW_COLORS =
        {
            new java.awt.Color(0.0f, 0.0f, 0.0f, 0.0f),
            new java.awt.Color(0.0f, 0.0f, 0.0f, 0.0f),
            new java.awt.Color(0.0f, 0.0f, 0.0f, 0.4f),
        };

        final float[] LED_ON_CORONA_FRACTIONS =
        {
            0.0f,
            0.6f,
            0.7f,
            0.8f,
            0.85f,
            1.0f
        };

        final java.awt.Color[] LED_ON_CORONA_COLORS =
        {
            new java.awt.Color(0.6470f, 1.0f, 0.0f, 0.0f),
            new java.awt.Color(0.6470f, 1.0f, 0.0f, 0.4f),
            new java.awt.Color(0.6470f, 1.0f, 0.0f, 0.25f),
            new java.awt.Color(0.6470f, 1.0f, 0.0f, 0.15f),
            new java.awt.Color(0.6470f, 1.0f, 0.0f, 0.05f),
            new java.awt.Color(0.6470f, 1.0f, 0.0f, 0.0f)
        };

        // Define gradients for the upper led
        final java.awt.RadialGradientPaint UPPER_LED_OFF_GRADIENT = new java.awt.RadialGradientPaint(UPPER_LED_CENTER, 5, LED_FRACTIONS, LED_OFF_COLORS);
        final java.awt.RadialGradientPaint UPPER_LED_ON_GRADIENT = new java.awt.RadialGradientPaint(UPPER_LED_CENTER, 5, LED_FRACTIONS, LED_ON_COLORS);
        final java.awt.RadialGradientPaint UPPER_LED_INNER_SHADOW_GRADIENT = new java.awt.RadialGradientPaint(UPPER_LED_CENTER, 5, LED_INNER_SHADOW_FRACTIONS, LED_INNER_SHADOW_COLORS);
        final java.awt.RadialGradientPaint UPPER_LED_ON_CORONA_GRADIENT = new java.awt.RadialGradientPaint(UPPER_LED_CENTER, 10, LED_ON_CORONA_FRACTIONS, LED_ON_CORONA_COLORS);

        // Define gradients for the lower led
        final java.awt.RadialGradientPaint LOWER_LED_OFF_GRADIENT = new java.awt.RadialGradientPaint(LOWER_LED_CENTER, 5, LED_FRACTIONS, LED_OFF_COLORS);
        final java.awt.RadialGradientPaint LOWER_LED_ON_GRADIENT = new java.awt.RadialGradientPaint(LOWER_LED_CENTER, 5, LED_FRACTIONS, LED_ON_COLORS);
        final java.awt.RadialGradientPaint LOWER_LED_INNER_SHADOW_GRADIENT = new java.awt.RadialGradientPaint(LOWER_LED_CENTER, 5, LED_INNER_SHADOW_FRACTIONS, LED_INNER_SHADOW_COLORS);
        final java.awt.RadialGradientPaint LOWER_LED_ON_CORONA_GRADIENT = new java.awt.RadialGradientPaint(LOWER_LED_CENTER, 10, LED_ON_CORONA_FRACTIONS, LED_ON_CORONA_COLORS);


        // Define light reflex data
        final java.awt.geom.Ellipse2D UPPER_LED_LIGHTREFLEX1 = new java.awt.geom.Ellipse2D.Float(8, 7, 4, 3);
        final java.awt.geom.Ellipse2D UPPER_LED_LIGHTREFLEX2 = new java.awt.geom.Ellipse2D.Float(8, 12, 4, 3);
        final java.awt.geom.Ellipse2D LOWER_LED_LIGHTREFLEX = new java.awt.geom.Ellipse2D.Float(8, 22, 4, 3);

        final java.awt.geom.Point2D UPPER_LED_LIGHTREFLEX1_START = new java.awt.geom.Point2D.Float(0, 7);
        final java.awt.geom.Point2D UPPER_LED_LIGHTREFLEX1_STOP = new java.awt.geom.Point2D.Float(0, 10);

        final java.awt.geom.Point2D UPPER_LED_LIGHTREFLEX2_START = new java.awt.geom.Point2D.Float(0, 12);
        final java.awt.geom.Point2D UPPER_LED_LIGHTREFLEX2_STOP = new java.awt.geom.Point2D.Float(0, 15);

        final java.awt.geom.Point2D LOWER_LED_LIGHTREFLEX_START = new java.awt.geom.Point2D.Float(0, 22);
        final java.awt.geom.Point2D LOWER_LED_LIGHTREFLEX_STOP = new java.awt.geom.Point2D.Float(0, 25);

        final float[] LIGHT_REFLEX_FRACTIONS =
        {
            0.0f,
            1.0f
        };

        final java.awt.Color[] LIGHTREFLEX_COLORS =
        {
            new java.awt.Color(1.0f, 1.0f, 1.0f, 0.4f),
            new java.awt.Color(1.0f, 1.0f, 1.0f, 0.0f)
        };

        final java.awt.Color[] LIGHTREFLEX_COLORS2 =
        {
            new java.awt.Color(1.0f, 1.0f, 1.0f, 0.0f),
            new java.awt.Color(1.0f, 1.0f, 1.0f, 0.4f)
        };

        // Define light reflex gradients
        final java.awt.LinearGradientPaint UPPER_LED_LIGHTREFLEX1_GRADIENT = new java.awt.LinearGradientPaint(UPPER_LED_LIGHTREFLEX1_START, UPPER_LED_LIGHTREFLEX1_STOP, LIGHT_REFLEX_FRACTIONS, LIGHTREFLEX_COLORS);
        final java.awt.LinearGradientPaint UPPER_LED_LIGHTREFLEX2_GRADIENT = new java.awt.LinearGradientPaint(UPPER_LED_LIGHTREFLEX2_START, UPPER_LED_LIGHTREFLEX2_STOP, LIGHT_REFLEX_FRACTIONS, LIGHTREFLEX_COLORS2);
        final java.awt.LinearGradientPaint LOWER_LED_LIGHTREFLEX_GRADIENT = new java.awt.LinearGradientPaint(LOWER_LED_LIGHTREFLEX_START, LOWER_LED_LIGHTREFLEX_STOP, LIGHT_REFLEX_FRACTIONS, LIGHTREFLEX_COLORS);


        switch(state)
        {
            case 0:
                // Draw upper LED OFF
                g2.setPaint(UPPER_LED_OFF_GRADIENT);
                g2.fill(UPPER_LED);
                g2.setPaint(UPPER_LED_INNER_SHADOW_GRADIENT);
                g2.fill(UPPER_LED);
                g2.setPaint(UPPER_LED_LIGHTREFLEX1_GRADIENT);
                g2.fill(UPPER_LED_LIGHTREFLEX1);

                // Draw lower LED OFF
                g2.setPaint(LOWER_LED_OFF_GRADIENT);
                g2.fill(LOWER_LED);
                g2.setPaint(LOWER_LED_INNER_SHADOW_GRADIENT);
                g2.fill(LOWER_LED);
                g2.setPaint(LOWER_LED_LIGHTREFLEX_GRADIENT);
                g2.fill(LOWER_LED_LIGHTREFLEX);
                break;
            case 1:
                // Draw uper LED ON
                g2.setPaint(UPPER_LED_ON_CORONA_GRADIENT);
                g2.fill(UPPER_LED_CORONA);
                g2.setPaint(UPPER_LED_ON_GRADIENT);
                g2.fill(UPPER_LED);
                g2.setPaint(UPPER_LED_INNER_SHADOW_GRADIENT);
                g2.fill(UPPER_LED);
                g2.setPaint(UPPER_LED_LIGHTREFLEX1_GRADIENT);
                g2.fill(UPPER_LED_LIGHTREFLEX1);                
                
                // Draw lower LED OFF
                g2.setPaint(LOWER_LED_OFF_GRADIENT);
                g2.fill(LOWER_LED);
                g2.setPaint(LOWER_LED_INNER_SHADOW_GRADIENT);
                g2.fill(LOWER_LED);
                g2.setPaint(LOWER_LED_LIGHTREFLEX_GRADIENT);
                g2.fill(LOWER_LED_LIGHTREFLEX);
                break;
            case 2:
                // Draw upper LED OFF
                g2.setPaint(UPPER_LED_OFF_GRADIENT);
                g2.fill(UPPER_LED);
                g2.setPaint(UPPER_LED_INNER_SHADOW_GRADIENT);
                g2.fill(UPPER_LED);
                g2.setPaint(UPPER_LED_LIGHTREFLEX1_GRADIENT);
                g2.fill(UPPER_LED_LIGHTREFLEX1);
                g2.setPaint(UPPER_LED_LIGHTREFLEX2_GRADIENT);
                g2.fill(UPPER_LED_LIGHTREFLEX2);


                // Draw lower LED ON
                g2.setPaint(LOWER_LED_ON_CORONA_GRADIENT);
                g2.fill(LOWER_LED_CORONA);
                g2.setPaint(LOWER_LED_ON_GRADIENT);
                g2.fill(LOWER_LED);
                g2.setPaint(LOWER_LED_INNER_SHADOW_GRADIENT);
                g2.fill(LOWER_LED);
                g2.setPaint(LOWER_LED_LIGHTREFLEX_GRADIENT);
                g2.fill(LOWER_LED_LIGHTREFLEX);
                break;
            default:
                // Draw upper LED OFF
                g2.setPaint(UPPER_LED_OFF_GRADIENT);
                g2.fill(UPPER_LED);
                g2.setPaint(UPPER_LED_INNER_SHADOW_GRADIENT);
                g2.fill(UPPER_LED);
                g2.setPaint(UPPER_LED_LIGHTREFLEX1_GRADIENT);
                g2.fill(UPPER_LED_LIGHTREFLEX1);

                // Draw lower LED OFF
                g2.setPaint(LOWER_LED_OFF_GRADIENT);
                g2.fill(LOWER_LED);
                g2.setPaint(LOWER_LED_INNER_SHADOW_GRADIENT);
                g2.fill(LOWER_LED);
                g2.setPaint(LOWER_LED_LIGHTREFLEX_GRADIENT);
                g2.fill(LOWER_LED_LIGHTREFLEX);
                break;
        }

        g2.dispose();

        return IMAGE;
    }

    public boolean isBlinking()
    {
        return this.blinking;
    }

    public void setBlinking(boolean blinking)
    {
        if (blinking)
        {
            this.blinking = blinking;
            BLINKING_TIMER.start();
        }
        else
        {
            this.blinking = false;
            currentImage = LED_OFF_OFF;
            repaint();
            BLINKING_TIMER.stop();
        }
    }
    
    @Override
    public java.awt.Dimension getSize()
    {
        return new java.awt.Dimension(20, 35);
    }

    @Override
    public java.awt.Dimension getPreferredSize()
    {
        return new java.awt.Dimension(20, 35);
    }

    @Override
    public java.awt.Dimension getSize(java.awt.Dimension rv)
    {
        return new java.awt.Dimension(20, 35);
    }

    @Override
    public void actionPerformed(java.awt.event.ActionEvent event)
    {
        toggle = !toggle;

        if (toggle)
        {
            currentImage = LED_ON_OFF;
        }
        else
        {
            currentImage = LED_OFF_ON;
        }

        repaint();
    }
}
