/*
 * To change this template, choose Tools | Templates
 * and open the template in the editor.
 */

/*
 * Main.java
 *
 * Created on 26.01.2010, 17:11:23
 */
package eventtalkboard;

/**
 *
 * @author hansolo
 */
public class Main extends javax.swing.JFrame
{
    /** Creates new form Main */
    public Main()
    {        
        initComponents();
        
        importXmlData();
    }

    private void importXmlData()
    {
        final java.text.DateFormat DF = new java.text.SimpleDateFormat("dd.MM.yyyy");

        try
        {
            final java.io.File TALK_LIST_FILE = new java.io.File("talklist.xml");
            if (TALK_LIST_FILE.exists())
            {
                javax.xml.parsers.DocumentBuilderFactory dbf = javax.xml.parsers.DocumentBuilderFactory.newInstance();
                javax.xml.parsers.DocumentBuilder db = dbf.newDocumentBuilder();
                org.w3c.dom.Document doc = db.parse(TALK_LIST_FILE);
                doc.getDocumentElement().normalize();
                //System.out.println("Root element " + doc.getDocumentElement().getNodeName());
                
                org.w3c.dom.NodeList eventNodeList = doc.getElementsByTagName("event");
                for (int s = 0 ; s < eventNodeList.getLength() ; s++)
                {
                    org.w3c.dom.Node firstNode = eventNodeList.item(s);

                    if (firstNode.getNodeType() == org.w3c.dom.Node.ELEMENT_NODE)
                    {
                        org.w3c.dom.Element firstElement = (org.w3c.dom.Element) firstNode;

                        org.w3c.dom.NodeList nameElementList = firstElement.getElementsByTagName("name");
                        org.w3c.dom.Element nameElement = (org.w3c.dom.Element) nameElementList.item(0);
                        org.w3c.dom.NodeList nameNodeList = nameElement.getChildNodes();
                        //System.out.println("Name : " + (nameNodeList.item(0)).getNodeValue());

                        org.w3c.dom.NodeList logoElementList = firstElement.getElementsByTagName("logo");
                        org.w3c.dom.Element logoElement = (org.w3c.dom.Element) logoElementList.item(0);
                        org.w3c.dom.NodeList logoNodeList = logoElement.getChildNodes();
                        //System.out.println("Logo : " + (logoNodeList.item(0)).getNodeValue());

                        board.setEventTitle((nameNodeList.item(0)).getNodeValue());

                        board.logoPanel.setLogoFileName((logoNodeList.item(0)).getNodeValue());
                    }
                }

                org.w3c.dom.NodeList dateNodeList = doc.getElementsByTagName("date");
                for (int s = 0 ; s < dateNodeList.getLength() ; s++)
                {
                    org.w3c.dom.Node firstNode = dateNodeList.item(s);

                    if (firstNode.getNodeType() == org.w3c.dom.Node.ELEMENT_NODE)
                    {
                        org.w3c.dom.Element firstElement = (org.w3c.dom.Element) firstNode;

                        org.w3c.dom.NodeList dayElementList = firstElement.getElementsByTagName("day");
                        org.w3c.dom.Element dayElement = (org.w3c.dom.Element) dayElementList.item(0);
                        org.w3c.dom.NodeList dayNodeList = dayElement.getChildNodes();                        
                        String day = dayNodeList.item(0).getNodeValue();
                        if (day.length() == 1)
                        {
                            day = "0" + day;
                        }

                        org.w3c.dom.NodeList monthElementList = firstElement.getElementsByTagName("month");
                        org.w3c.dom.Element monthElement = (org.w3c.dom.Element) monthElementList.item(0);
                        org.w3c.dom.NodeList monthNodeList = monthElement.getChildNodes();
                        String month = monthNodeList.item(0).getNodeValue();
                        if (month.length() == 1)
                        {
                            month = "0" + month;
                        }

                        org.w3c.dom.NodeList yearElementList = firstElement.getElementsByTagName("year");
                        org.w3c.dom.Element yearElement = (org.w3c.dom.Element) yearElementList.item(0);
                        org.w3c.dom.NodeList yearNodeList = yearElement.getChildNodes();
                        String year = yearNodeList.item(0).getNodeValue();
                        if (year.length() == 2)
                        {
                            year = "20" + year;
                        }

                        board.setEventDate(DF.parse(day + "." + month + "." + year));
                    }
                }

                org.w3c.dom.NodeList talkNodeList = doc.getElementsByTagName("talk");
                for (int s = 0; s < talkNodeList.getLength(); s++)
                {
                    org.w3c.dom.Node firstNode = talkNodeList.item(s);

                    if (firstNode.getNodeType() == org.w3c.dom.Node.ELEMENT_NODE)
                    {
                        org.w3c.dom.Element firstElement = (org.w3c.dom.Element) firstNode;

                        org.w3c.dom.NodeList timeElementList = firstElement.getElementsByTagName("time");
                        org.w3c.dom.Element timeElement = (org.w3c.dom.Element) timeElementList.item(0);
                        org.w3c.dom.NodeList timeNodeList = timeElement.getChildNodes();
                        //System.out.println("Time : " + (timeNodeList.item(0)).getNodeValue());

                        org.w3c.dom.NodeList titleElementList = firstElement.getElementsByTagName("title");
                        org.w3c.dom.Element titleElement = (org.w3c.dom.Element) titleElementList.item(0);
                        org.w3c.dom.NodeList titleNodeList = titleElement.getChildNodes();
                        //System.out.println("Title : " + (titleNodeList.item(0)).getNodeValue());

                        org.w3c.dom.NodeList speakerElementList = firstElement.getElementsByTagName("speaker");
                        org.w3c.dom.Element speakerElement = (org.w3c.dom.Element) speakerElementList.item(0);
                        org.w3c.dom.NodeList speakerNodeList = speakerElement.getChildNodes();
                        //System.out.println("Speaker : " + (speakerNodeList.item(0)).getNodeValue());

                        org.w3c.dom.NodeList locationElementList = firstElement.getElementsByTagName("location");
                        org.w3c.dom.Element locationElement = (org.w3c.dom.Element) locationElementList.item(0);
                        org.w3c.dom.NodeList locationNodeList = locationElement.getChildNodes();
                        //System.out.println("Location : " + (locationNodeList.item(0)).getNodeValue());

                        board.addEvent((timeNodeList.item(0)).getNodeValue(), (titleNodeList.item(0)).getNodeValue(), (speakerNodeList.item(0)).getNodeValue(), (locationNodeList.item(0)).getNodeValue());
                    }                    
                }
            }
        }
        catch (Exception exception)
        {
            exception.printStackTrace();
        }
    }

    /** This method is called from within the constructor to
     * initialize the form.
     * WARNING: Do NOT modify this code. The content of this method is
     * always regenerated by the Form Editor.
     */
    @SuppressWarnings("unchecked")
    // <editor-fold defaultstate="collapsed" desc="Generated Code">//GEN-BEGIN:initComponents
    private void initComponents() {

        board = new eventtalkboard.BoardPanel();

        setDefaultCloseOperation(javax.swing.WindowConstants.EXIT_ON_CLOSE);
        setLocation(new java.awt.Point(0, 0));
        setPreferredSize(new java.awt.Dimension(1608, 630));
        setResizable(false);
        setSize(new java.awt.Dimension(1608, 630));

        board.setName("board"); // NOI18N

        org.jdesktop.layout.GroupLayout layout = new org.jdesktop.layout.GroupLayout(getContentPane());
        getContentPane().setLayout(layout);
        layout.setHorizontalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(board, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
        );
        layout.setVerticalGroup(
            layout.createParallelGroup(org.jdesktop.layout.GroupLayout.LEADING)
            .add(board, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE, org.jdesktop.layout.GroupLayout.DEFAULT_SIZE, org.jdesktop.layout.GroupLayout.PREFERRED_SIZE)
        );

        pack();
    }// </editor-fold>//GEN-END:initComponents

    /**
     * @param args the command line arguments
     */
    public static void main(String args[])
    {
        java.awt.EventQueue.invokeLater(new Runnable()
        {
            @Override
            public void run()
            {
                Main app = new Main();
                app.setLocationRelativeTo(null);                
                app.pack();
                app.setVisible(true);
            }
        });
    }
    // Variables declaration - do not modify//GEN-BEGIN:variables
    private eventtalkboard.BoardPanel board;
    // End of variables declaration//GEN-END:variables
}
